//
// database object
//

#ifndef _DATABASE_H_
#define _DATABASE_H_

#include <string>

#include <mysql/mysql.h>

#include "dbresult.h"

#define DB_CONNECTION_NONE  0
#define DB_CONNECTION_OK    1
#define DB_CONNECTION_BAD   2

#define DB_COMMAND_OK   0				// OK - command executed
#define DB_EMPTY_QUERY  1				// Query didn't return tuples
#define DB_TUPLES_OK    2				// Query returned tuples
#define DB_ERROR        5				// A database error
#define DB_BAD_RESPONSE 6				// Bad response from Database
#define DB_UNEXPECTED   7				// This shouldn't ever happen

#define DB_USER "nicoleusr"
#define DB_PASSWORD NULL

/**
 * A MySQL C++ wrapper object, based on the mysql C++ wrapper library written
 * by Roland Haenel <rh_at_ginster.net>
 *
 * Modified somewhat for use in NICOLE
 */

class Database
{
private:
	MYSQL mysql;
	/**
	 * TRUE if a we are connected to a database, FALSE if not
	 */
	int connected;
	/**
	 * a string containing the error message/status
	 */
	string error;

public:
	  Database (  );
	int init (  );
	string error_message (  );
	int connect ( string host, string db );
	int status (  );							// Return status information

	void disconnect (  );					// Disconnect from database
	int reset (  );								// Reset connection

	DBResult *exec ( char *sqlFormat, ... );	// Execute arbitrary SQL cmd
	// Same as above, reuse res
	void exec ( DBResult * res, char *sqlFormat, ... );

	 ~Database (  );

};

#endif
