//
// log.cpp
//

#include <string>
#include <iostream>
#include <fstream>
using namespace std;

#include "log.h"

/**
 * Opens up a log file called \e fname for appending.
 *
 * \param fname the name of the file to log to.
 */
Log::Log ( string fname )
{

	logfile.open ( fname.begin (  ), ios::app );

	logfile << "-- Session started." << endl;
}

/**
 * Records a string to the log file
 *
 * \param s the string to be appended to the log file
 */
void Log::record ( string s )
{
	logfile << s << endl;
}

/**
 * Closes down the log file
 */
Log::~Log (  )
{
	logfile << "-- Session terminiated." << endl;

	logfile.close (  );
}
