//
// responder.cpp
//

#include <string>
#include <deque>
using namespace std;

#include "responder.h"
#include "database.h"

Responder::Responder (  )
{
	//
	// establish a connection to the database
	//
	if ( db.init (  ) != DB_COMMAND_OK )
	{
		cerr << "Unable to initialize database: " << db.
			error_message (  ) << endl;
		exit ( 1 );
	}

	// Connect to database on localhost
	if ( db.connect ( "localhost", "NICOLE" ) != DB_CONNECTION_OK )
	{
		cerr << "Unable connect to database 'NICOLE': "
			<< db.error_message (  ) << endl;
		exit ( 1 );
	}

}

string Responder::find_word ( string a, string b, string c, string d )
{
	char **field;

//  int i;
	long total = 0;
	long tally = 0;
	long marker = 0;

	string nextword = "";

	// First find out how many occurances we have 
	db.exec ( &dbres,
						"SELECT sum(freq) FROM vocabulary WHERE w1 = '%s' AND w2 = '%s' AND w3 = '%s' AND w4 = '%s'",
						a.c_str (  ), b.c_str (  ), c.c_str (  ), d.c_str (  ) );

	field = dbres.getTuple (  );
	if ( field[0] == NULL )
	{
		// we could find a new word.. abort!
//    cout << "find_word() FOUND NOTHING" << endl;
		return "";
	}
	else
	{
		// get the total possible frequency combinations
		total = atoi ( field[0] );
	}

	//cout << "Total: " << total << endl;

	marker = rand (  ) % total + 1;

	//cout << "Marker: " << marker << endl;

	// Now lets find the next word to use
	db.exec ( &dbres,
						"SELECT w1,w2,w3,w4,w5,freq FROM vocabulary WHERE w1 = '%s' AND w2 = '%s' AND w3 = '%s' AND w4 = '%s'",
						a.c_str (  ), b.c_str (  ), c.c_str (  ), d.c_str (  ), total );
	field = dbres.getTuple (  );

	while ( ( field != NULL ) && ( tally < marker ) )
	{
		// cout << "Tally: " << tally << endl;

		nextword = field[4];				// the 5th word in the query
		tally += atoi ( field[5] );	// the frequency count

		//for (i = 0; i < dbres.nrFields(); i++)
		//{
		//  cout << field[i] << " | ";
		//}
		//cout << endl;
		field = dbres.getTuple (  );
	}

	return nextword;
}

string Responder::get ( string a, string b, string c, string d, string e )
{
	string reply = "";
	string word = "";

//  cout << "Matrix: " << a
//       << "|" << b
//       << "|" << c
//       << "|" << d
//       << "|" << e << endl;

	// get the next available word
	word = find_word ( b, c, d, e );

	if ( word == "" )
	{
		reply = "";
	}
	else
	{
		reply = word;

		while ( word[word.length (  ) - 1] != '.' )
		{
			a = b;
			b = c;
			c = d;
			d = e;
			e = word;
			word = find_word ( b, c, d, e );
//      cout << "WORD: " << word << endl;
			reply += " " + word;
		}
	}
	return reply;
}

Responder::~Responder (  )
{
}
